#appModules/jmc.py
#A part of NonVisual Desktop Access (NVDA)
#This file is covered by the GNU General Public License.
#See the file COPYING for more details.
#Copyright (C) 2010 Aleksey Sadovoy <lex@progger.ru>

"""App module for Jaba MUD Client
"""

import controlTypes
import oleacc
import api
import config
from NVDAObjects.window import Window, DisplayModelLiveText
from NVDAObjects.IAccessible import ContentGenericClient
from appModules import _default

class Input(Window):

	def event_gainFocus(self):
		super(Input, self).event_gainFocus()
		try:
			output = self.parent.parent.parent.parent.firstChild.firstChild.firstChild.firstChild
		except AttributeError:
			output = None
		if isinstance(output, DisplayModelLiveText):
			output.startMonitoring()
			api.setNavigatorObject(output)
			self._output = output
		else:
			self._output = None

	def event_loseFocus(self):
		if self._output:
			self._output.stopMonitoring()

class AppModule(_default.AppModule):

	def chooseNVDAObjectOverlayClasses(self, obj, clsList):
		if obj.windowClassName == "AfxFrameOrView42" and obj.windowControlID == 59648 and obj.IAccessibleRole== oleacc.ROLE_SYSTEM_CLIENT:
			try:
				clsList.remove(ContentGenericClient)
			except ValueError:
				pass
			clsList.insert(0, DisplayModelLiveText)
		elif  obj.windowClassName=="Edit" and obj.windowControlID==1000:
			clsList.insert(0, Input)

	def event_appGainFocus(self):
		#force followCaret to false, as it is inconvenient for user to turn it off each time
		self._lastFfollowCaret=config.conf["reviewCursor"]["followCaret"]
		config.conf["reviewCursor"]["followCaret"]=False

	def event_appLoseFocus(self):
		if hasattr(self, '_lastFollowCaret'):
			config.conf["reviewCursor"]["followCaret"]=self._lastFollowCared
